#include "Algo.h"
#include <algorithm>
	
/* un premier algo d'approximation: on choisit un sommet dans la plus grande classe de connexite,
de degre maximum; k>=1. */
int Algo::a1(int k, int p) { // p==parametre pour l'algo probabiliste
       
	int res=0,max,compt;
	// bien sur si k>=n, on n'a rien a faire!
	if (g.n<=k) return res;
	
	while (true) { 
		// calcul du nombre maxi d'elements dans une partie connexe du graphe
		g.mAJConnexe();
		for (int i=g.n-1; i>=0; i--) compteur[i]=0;
		max=-1;
		for (int i=g.n-1; i>=0; i--)
			if (++compteur[g.classeConnexite[i]]>max) max=compteur[g.classeConnexite[i]]; 
		if (max<=k) return res;
		
		max=-1;
		// choix d'un element dont la classe de connexite est la plus grande possible (de cardinal>delta)
		for (int i=g.n-1; i>=0; i--) dejaTraite[i]=false;
		for (int i=g.n-1; i>=0; i--) 
			if (!dejaTraite[i] && g.indices_connex[i]) {
				compt=0;
				for (int j=g.n-1; j>=0; j--) 
					if (g.cl_connex[i][j]) {
						compt++;
						dejaTraite[j]=true;
					}
				if (compt>max) { 
					max=compt;
					temp.clear(); 
					for (int j=g.n-1; j>=0; j--)
						if (g.cl_connex[i][j]) temp.push_back(j);
				}
				else if (compt>=max) {
					for (int j=g.n-1; j>=0; j--)
						if (g.cl_connex[i][j]) temp.push_back(j);
				}		
			}
     
		// recherche des sommets de degre max
		max=-1;
		for (int i=(int)temp.size()-1; i>=0; i--) {
			compt=0;
			for (int j=g.n-1; j>=0; j--)
				if (g.tab[temp[i]][j]) compt++;		
			if (compt>max) {
				max=compt;
				tabMax.clear();
				tabMax.push_back(temp[i]);
			}
			else if (compt>=max) tabMax.push_back(temp[i]); 
		}
					
		max=tabMax[(rand()+p)%(int)tabMax.size()];
		sol.push_back(g.noms[max]);
		g.remove(max);
		res++; 
	}
	return 0;
}
	
/* un second algo d'approximation: on choisit les sommets tels que les parties connexes obtenues en les
retirant soient de cardinal minimum, apres selection comme en a1; c'est donc un raffinement du precedent */
int Algo::a2(int k, int p) { // p==parametre pour l'algo probabiliste

	int res=0,opt,compt;
	// bien sur si k>=n, on n'a rien a faire!
	if (g.n<=k) return res;
	    
	while (true) { 
		// calcul du nombre maxi d'elements dans une partie connexe du graphe
		g.mAJConnexe();
		for (int i=g.n-1; i>=0; i--) compteur[i]=0;
		opt=-1;
		for (int i=g.n-1; i>=0; i--)
			if (++compteur[g.classeConnexite[i]]>opt) opt=compteur[g.classeConnexite[i]]; 
		if (opt<=k) return res;
		
		g.mAJConnexe();
		opt=-1;
		// choix d'un element dont la classe de connexite est la plus grande possible
		for (int i=g.n-1; i>=0; i--) dejaTraite[i]=false;
		for (int i=g.n-1; i>=0; i--) 
			if (!dejaTraite[i] && g.indices_connex[i]) {
				compt=0;
				for (int j=g.n-1; j>=0; j--) 
					if (g.cl_connex[i][j]) {
						compt++;
						dejaTraite[j]=true;
					}
				if (compt>opt) { 
					opt=compt;
					temp.clear(); 
					for (int j=g.n-1; j>=0; j--)
						if (g.cl_connex[i][j]) temp.push_back(j);
				}
				else if (compt>=opt) {
					for (int j=g.n-1; j>=0; j--)
						if (g.cl_connex[i][j]) temp.push_back(j);
				}		
			}
		
		// choix d'un element de degre max
		opt=-1;
		for (int i=(int)temp.size()-1; i>=0; i--) {
			compt=0;
			for (int j=g.n-1; j>=0; j--)
				if (g.tab[temp[i]][j]) compt++;		
			if (compt>opt) {
				opt=compt;
				tabMax.clear();
				tabMax.push_back(temp[i]);
			}
			else if (compt>=opt) tabMax.push_back(temp[i]); 
		}
			
		// recherche des cardinaux des classes de connexite
		opt=g.n;
		for (int i=(int)tabMax.size()-1; i>=0; i--) {
			g.remove(tabMax[i]); 
			compt=g.maxConnexe();
			g.restitue(tabMax[i]);
			if (compt<opt) {
				opt=compt; 
				temp.clear();
				temp.push_back(tabMax[i]); 
			}
			else if (compt<=opt) temp.push_back(tabMax[i]); 
		}

		opt=temp[(rand()+p)%(int)temp.size()]; 
		sol.push_back(g.noms[opt]); 
		g.remove(opt); 
		res++; 
	}
}

// un troisieme algo d'approximation:
// on maximise la taille minimale d'une partie connexe resultante, et on penalise les sommets
// qui une fois retires ne changent pas le nombres de classes de connexite
// la note d'un sommet est: 0 dans le dernier cas, card(ensemble_min_connexe) dans le second
int Algo::a3(int k, int p) { // p==parametre pour l'algo probabiliste

	int res=0,opt,nbConnex,aux,compt;
	// bien sur si k>=n, on n'a rien a faire!
	if (g.n<=k) return res;
	    
	while (true) { 
		// calcul du nombre maxi d'elements dans une partie connexe du graphe
		g.mAJConnexe();
		for (int i=g.n-1; i>=0; i--) compteur[i]=0;
		opt=-1;
		for (int i=g.n-1; i>=0; i--)
			if (++compteur[g.classeConnexite[i]]>opt) opt=compteur[g.classeConnexite[i]]; 
		if (opt<=k) return res;
		
		// compteur[i]: note de i
		
		// recherche du nombre actuel de classes de connexite
		nbConnex=0;
		for (int i=g.n-1; i>=0; i--) 
			if (g.indices_connex[i]) nbConnex++;
		
		// verification que le nombre de classes de connexite augmente, 
		// puis notation des sommets
		for (int i=g.n-1; i>=0; i--) {
			compteur[i]=0;
			g.remove(i);
			g.mAJConnexe();
			aux=0;
			for (int j=g.n-1; j>=0; j--) 
				if (g.indices_connex[j]) aux++;
			
			if (aux>nbConnex) {
				opt=g.n;
				for (int j=g.n-1; j>=0; j--) 
					if (g.indices_connex[j]) {
						aux=0;
						for (int k=g.n-1; k>=0; k--) 
							if (g.cl_connex[j][k]) aux++;
						if (aux<opt) {
							opt=aux;
							compteur[i]=aux;
						}
					}	
			}
			g.restitue(i);
		}

		// choix d'un element de notation maximale
		opt=-1;
		for (int i=g.n-1; i>=0; i--) { 
			if (compteur[i]>opt) { 
				opt=compteur[i];
				tabMax.clear();
				tabMax.push_back(i);
			}
			else if (compteur[i]>=opt) tabMax.push_back(i); 
		}
		
		// raffinement avec le degre maximal
		opt=-1;
		for (int i=(int)tabMax.size()-1; i>=0; i--) {
			compt=0;
			for (int j=g.n-1; j>=0; j--)
				if (g.tab[tabMax[i]][j]) compt++;		
			if (compt>opt) {
				opt=compt;
				temp.clear();
				temp.push_back(tabMax[i]);
			}
			else if (compt>=opt) temp.push_back(tabMax[i]); 
		}

		opt=temp[(rand()+p)%(int)temp.size()]; 
		sol.push_back(g.noms[opt]); 
		g.remove(opt); 
		res++; 
	}
}
        
/* algo probabiliste base sur le premier algorithme */
int Algo::proba1(int k) { 
	int best=g.n,tmp;
	Graphe sav;
	int aux;
	if (g.n>150) aux=50;
	else if (g.n>60) aux=g.n/3+1;
	else aux=20;
	for (int i=aux; i>=0; i--) { 
		// attention il faut sauvegarder le graphe d'une iteration sur l'autre
		sav=Graphe(g); 
		tmp=a1(k,i); 
		if (tmp<best) best=tmp; 
		g=sav; 
	}
	std::vector<int> res_final;
	for (int i=(int)sol.size()-best; i<(int)sol.size(); i++) res_final.push_back(sol[i]);
	sol=res_final;
	return best;
}	
	
/* algo probabiliste base sur le second algorithme */
int Algo::proba2(int k) {
	int best=g.n,tmp;
	Graphe sav;
	int aux;
	if (g.n>150) aux=50;
	else if (g.n>60) aux=g.n/3+1;
	else aux=20;
	for (int i=aux; i>=0; i--) {
		// attention il faut sauvegarder le graphe d'une iteration sur l'autre
		sav=Graphe(g); 
		tmp=a2(k,i); 
		if (tmp<best) best=tmp;
		g=sav;
	}
	std::vector<int> res_final;
	for (int i=(int)sol.size()-best; i<(int)sol.size(); i++) res_final.push_back(sol[i]);
	sol=res_final;
	return best;
}

/* algo probabiliste base sur le troisieme algorithme */
int Algo::proba3(int k) {
	int best=g.n,tmp;
	Graphe sav;
	int aux;
	if (g.n>150) aux=50;
	else if (g.n>60) aux=g.n/3+1;
	else aux=20;
	for (int i=aux; i>=0; i--) {
		// attention il faut sauvegarder le graphe d'une iteration sur l'autre
		sav=Graphe(g); 
		tmp=a3(k,i); 
		if (tmp<best) best=tmp;
		g=sav;
	}
	std::vector<int> res_final;
	for (int i=(int)sol.size()-best; i<(int)sol.size(); i++) res_final.push_back(sol[i]);
	sol=res_final;
	return best;
}
	
/* algo exact pour verification avec n petit */
int Algo::res_exact(int k) {
	if (g.n<=k || g.maxConnexe()<=k) return 0;
	Graphe sav;
	int t=1;
	while (true) { 
		valI.clear();
		for (int i=g.n-1; i>=0; i--) {
			compteur[i]=0;
			for (int j=g.n-1; j>=0; j--) 
				if (g.tab[i][j]) compteur[i]++;
				valI.push_back(ValIndice(compteur[i],i));
		}
		sort(valI.begin(),valI.end()); 
		for (int i=g.n-1; i>=0; i--) {
			sol.push_back(valI[i].ind);
			sav=Graphe(g);
			g.remove(valI[i].ind); 
			if (aux_exact(k,t-1)) return t;
			g=sav;
			sol.pop_back();
		} 
		t++;
	}
	return 0;
}
	
/* fonction auxiliaire */
bool Algo::aux_exact(int k, int t) {
	if (g.maxConnexe()<=k) return true;
	if (t<=0) return false;  
	Graphe sav;
	std::vector<ValIndice> vI; 
	// reordonnancement si t>1)
	if (t>1) {
		for (int i=g.n-1; i>=0; i--) {
			compteur[i]=0;
			for (int j=g.n-1; j>=0; j--) 
				if (g.tab[i][j]) compteur[i]++;
			vI.push_back(ValIndice(compteur[i],i));
		}	
		sort(valI.begin(),valI.end());
		for (int i=g.n-1; i>=0; i--) {
			sol.push_back(g.noms[vI[i].ind]);
			sav=Graphe(g);
			g.remove(vI[i].ind);
			if (aux_exact(k,t-1)) return true;
			g=sav;
			sol.pop_back();
		}
	}
	else {
		for (int i=g.n-1; i>=0; i--) {
			sol.push_back(g.noms[i]);
			sav=Graphe(g);
			g.remove(i);
			if (aux_exact(k,t-1)) return true;
			g=sav;
			sol.pop_back();
		}
	}
	return false;
}	
	
// affichage d'une solution 
void Algo::affiche() { 
	for (int i=(int)sol.size()-1; i>0; i--) std::cout << sol[i] << ", ";
	if (!sol.empty()) std::cout << sol[0] << std::endl;
	return;
}	
