#ifndef _Algo
#define _Algo

/*
* Classe implementant quelques algos de k-dislocation
*/

#include <iostream>
#include <vector>
#include "Graphe.h"

/* df. des fonctions rand(), srand() et de RAND_MAX + time() */
#include <cstdlib>

/* structure pour reordonner les indices dans l'algo exact */
struct ValIndice {
	ValIndice (int v, int i) {
		val=v;
		ind=i;
	}
	bool operator< (const ValIndice& v) const {
		return (val<v.val);
	}
	int val;
	int ind;
};

class Algo {
      
public:
       
	/* constructeur vide */
	Algo() {}
       
	/* constructeur a partir d'un graphe binaire */
	Algo(const Graphe& g) { 
		this->g=Graphe(g); 
		compteur=(int*)malloc((g.n)*sizeof(int)); 
		dejaTraite=(bool*)malloc(g.n*sizeof(bool));
		// initialisation du generateur aleatoire
		srand(time(NULL));
	}

	/* algos d'approximation */
	int a1(int k, int p);
	int a2(int k, int p);
	int a3(int k, int p);

	/* algos probabilistes correspondants */
	int proba1(int k);
	int proba2(int k);
	int proba3(int k);

	/* algo exact pour verification avec n petit */
	int res_exact(int k);
	bool aux_exact(int k, int t);

	/* affichage d'une solution */
	void affiche();

	/* destructeur */
	~Algo() { /*
		free(compteur);
		free(cardConnex);
		free(dejaTraite); --> segFault */
	} 
       
private:       
            
	/* graphe sur lequel on applique l'algo */
	Graphe g;
       
	/* tableau ou l'on stocke l'ensemble de sommets trouve dans l'algo */
	std::vector<int> sol;
       
	/* tableau utile a plusieurs reprises */
	int* compteur;
       
	/* vecteurs correspondants */
	std::vector<int> tabMax,temp;

	/* tableau d'indices ordonnes */
	std::vector<ValIndice> valI;  
       
	/* tableau pour stocker les elements deja traites */
	bool* dejaTraite;
        
};

#endif

       
